#ifndef LIP_MAC_RX_H
#define LIP_MAC_RX_H


/***************************************************************************//**
 @addtogroup lip_mac
 @{
 @file lip_mac_rx.h
 @brief Файл содержит определения функций для работы с очерядями приема пакетов

 В данном файле реализована работа с очередями пакетов на прием.
 Всего может быть до 4-х очередей с разным приоритетом (очередь с номером 0 -
 наиболее приоритетная). Размеры очередей и их количество определяются параметрами
 конфигурации.

 Данные функции являются связующим звеном между логикой приема конкретного порта
 под конкретный MAC-контроллер и логикой дольнейшей обработки стеком.

 По приему нового кадра порт вызывает (как правило из обработчика прерывания)
 на каждый принятый пакет функцию lip_mac_rx_proc_frame(),
 передавая информацию и указатель на данные принятого кадра,
 в результате чего кадр копируются в одну из очередей.

 Далее в основном цикле выполнения работ логика стека получает принятые пакет
 с помощью lip_mac_rx_get_frame(), которая возвращает принятый пакет из наиболее
 приоритетной очереди, обрабатывает его, после чего вызывает lip_mac_rx_get_frame_finish()
 для указания, что данные кадра больше не нужны и место в очереди снова свободно.


 @author Borisov Alexey <borisov@lcard.ru>
******************************************************************************/


#include "lip/ll/lip_ll.h"
#include "lip/lip_defs.h"
#include "lip_mac_rx_cfg_defs.h"


/** @brief Инициализация модуля работы с очередями приема пакетов */
void lip_max_rx_init(void);
/** @brief Завершение работы модуля работы с очередями приема пакетов */
void lip_max_rx_close(void);

/** @brief Сохранение принятого от порта кадра в одну из очередей для дальнейшей обработки */
void lip_mac_rx_proc_frame(t_lip_rx_ll_frame *ll_frame);
/** @brief Получение текущего наиболее приоритетного сохраненного кадра для обработки  */
t_lip_rx_frame *lip_mac_rx_get_frame(void);
/** @brief Завершение обработки полученного кадра  */
void lip_mac_rx_get_frame_finish(t_lip_rx_frame *frame);
/** @brief Получение счетчика отброщенных пакетов для заданной очереди приема */
uint32_t lip_max_rx_queue_get_drop_frames_cnt(uint8_t q_idx);

#if  LIP_MAC_RX_FRAME_PREPROC_CB
    /** @brief Ползовательская функция обработного вызова для обработки принятых кадров.

        Если вызов данной функции разрешен в настройках стека с помощью параметра
        #LIP_CFG_MAC_RX_FRAME_PREPROC_CB, то она вызывается непосредственно после
        приема пакета еще до помещения пакета в очередь, в контексте прерывания.

        Если фукнция вернет #LIP_ERR_SUCCESS, то пакет будет далее обработан штатным
        образом и помещен в одну из очередей для дальнейшей обработки, иначе пакет
        будет отброшен.

        Функция может использоваться как для изменения информации о пакете, так
        и для сверхприоритетной обработки пакета без помещения в очередь для
        фоновой обработки (в этом случае можно вернуть код ошибки
        #LIP_ERR_USER_DROP_REQUEST).

        Пользователь должен учитывать, что принятых пакет может быть разделен
        на две части (зависит от реализации порта)

        @param[in] ll_frame - указатель на структуру с информацией о принятом кадре и
                              его данных.
        @return  Код ошибки. #LIP_ERR_SUCCESS, если пакет должен далее обработан штатным
                 образом, другое значение, если пакет должен быть отброшен
    */
    t_lip_errs lip_mac_rx_frame_user_preproc(t_lip_rx_ll_frame *ll_frame);
#endif

#endif // LIP_MAC_RX_H
